import { SFCDescriptor, SFCTemplateCompileOptions } from '@vue/compiler-sfc';
import type { PluginContext, TransformPluginContext } from 'rollup';
import { ResolvedOptions } from '.';
export declare function transformTemplateAsModule(code: string, descriptor: SFCDescriptor, options: ResolvedOptions, pluginContext: TransformPluginContext, ssr: boolean): {
    code: string;
    map: any;
};
/**
 * transform the template directly in the main SFC module
 */
export declare function transformTemplateInMain(code: string, descriptor: SFCDescriptor, options: ResolvedOptions, pluginContext: PluginContext, ssr: boolean): {
    code: string;
    ast?: import("@vue/compiler-core").RootNode | undefined;
    preamble?: string | undefined;
    source: string;
    tips: string[];
    errors: (string | import("@vue/compiler-core").CompilerError)[];
    map?: import("source-map").RawSourceMap | undefined;
};
export declare function compile(code: string, descriptor: SFCDescriptor, options: ResolvedOptions, pluginContext: PluginContext, ssr: boolean): import("@vue/compiler-sfc").SFCTemplateCompileResults;
export declare function resolveTemplateCompilerOptions(descriptor: SFCDescriptor, options: ResolvedOptions, ssr: boolean): Omit<SFCTemplateCompileOptions, 'source'> | undefined;
//# sourceMappingURL=template.d.ts.map